import javax.swing.JFrame;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.Timer;
import java.awt.FlowLayout;
import java.awt.Dimension;
import java.awt.Color;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

/**
 * This version of Knappfonster has a timer that sets the color
 * of the panel to green once every 5 seconds.
 */
public class KnappfonsterMedTimer extends JFrame implements ActionListener {
	private JButton knapp1;
	private JButton knapp2 = new JButton("Gul");
	private JPanel  myJPanel = new JPanel();
	private Color   bakgrund;

	private final int delay = 5000; // msec
	private Timer timer = new Timer(delay, this);
	
	public KnappfonsterMedTimer(){
		super("Demo of javax.swing.Timer");
		knapp1 = new JButton("Röd");
		setLayout(new FlowLayout());
		add(knapp1);
		add(knapp2);
		add(myJPanel);
		knapp1.addActionListener(this);
		knapp2.addActionListener(this);
		myJPanel.setPreferredSize(new Dimension(200,200));
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setVisible(true);
		pack();
		timer.start(); // Start making reapeated calls to actionPerformed.	
	}
	
	public void actionPerformed(ActionEvent ae){
		if (ae.getSource() == knapp1) {
			myJPanel.setBackground(Color.RED);
		} else if (ae.getSource() == knapp2) {
			myJPanel.setBackground(Color.YELLOW);
		} else if (ae.getSource() == timer) { // Called once every 5 seconds.
			myJPanel.setBackground(Color.GREEN);	
		}
	}
	
	public static void main(String[] args){
		new KnappfonsterMedTimer();
	}
	
}
